VERSION 5.00
Begin VB.UserControl CodeEditor 
   BackColor       =   &H00FEFBF3&
   ClientHeight    =   3690
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4425
   FillColor       =   &H00C0C0C0&
   FillStyle       =   0  'Solid
   BeginProperty Font 
      Name            =   "Courier New"
      Size            =   9
      Charset         =   204
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H00525043&
   ScaleHeight     =   246
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   295
   ToolboxBitmap   =   "CodeEditor.ctx":0000
End
Attribute VB_Name = "CodeEditor"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Dim mText As String
Dim mSelStart As Long, mSelLenght As Long
Dim mReservedGroup As New ReservedGroup
Dim mHighLightGroup As New HighLightGroup
Dim hCaret As Long
Dim mHScroll As Long
Dim mVscroll As Long, mVScrollMax As Long, mOldVScroll As Long, mOldVScrollMax As Long
Dim mReservedEnable As Boolean
Dim mDefaulColor As OLE_COLOR
'Default Property Values:
Const m_def_Locked = False
Const m_def_Enable = True
Const m_def_hDC = 0
Const m_def_hWnd = 0
Const m_def_ReservedWordHighlightEnable = False
Const m_def_UserBarEnable = False
Const m_def_UserBarColor = &HFAECCB
Const m_def_UserBarWidth = 64
Const m_def_NumericBackColor = vbWhite
Const m_def_NumericColor = &HFEFBF3
Const m_def_NumericBarEnable = False
Const m_def_CommentsColor = &H8000&
Const m_def_StringColor = &H254067
Const m_def_StringSymbol = """"
Const m_def_Text = "TrickCode   2011 ..."
Const m_def_DefaulColor = &H525043
Const m_def_SingleLineComment = ";"
Const m_def_BackColor = &HC0C0C0
Const m_def_HighlightEnable = True
Const m_def_SelectionColor = vbBlue
Const m_def_OffsetTextX = 2
Const m_def_OffsetTextY = 2
'Property Variables:
Dim m_Locked As Boolean
Dim m_Enable As Boolean
Dim m_hDC As Long
Dim m_hWnd As Long
Dim m_ReservedWordHighlightEnable As Boolean
Dim m_UserBarEnable As Boolean
Dim m_UserBarColor As OLE_COLOR
Dim m_UserBarWidth As Long
Dim m_NumericBackColor As OLE_COLOR
Dim m_NumericColor As OLE_COLOR
Dim m_NumericBarEnable As Boolean
Dim m_CommentsColor As OLE_COLOR
Dim m_StringColor As OLE_COLOR
Dim m_StringSymbol As String
Dim m_CommentsSymbol As String
Dim m_HighlightEnable As Boolean
Dim m_SelectionColor As OLE_COLOR
Dim m_OffsetTextX As Long
Dim m_OffsetTextY As Long
Dim boolSelection As Boolean, tSelection As Long
Dim NumericWidth As Long, OldNumericWidth As Long
Dim hSelectionBrush As Long
Dim nBrush As Long, uBrush As Long, oldBitmap As Long, tempDC As Long
Dim bufCharCurLine As Long, oldLine As Long ' For GET_LINE procedure, fast get current line
Dim LFCB As Boolean, oldLinelfc As Long ' For LINE_FROMCHAR procedure, fast get current line
Dim GLC As Boolean, oldLineglc As Long ' For LINE_FROMCHAR procedure, fast get current line
Dim OCFL As Long, OCFLL As Long, Focus As Boolean
Const DT_CURRENTLINE = -1
Const DT_FROMCURRENT_LINE = -2
Const DT_ALL_LINE = -1
Const DS_ALL_CHAR = -1
'Events
Public Event ChangeVScroll(Max As Long, Value As Long)
Public Event ChangeText(Cancel As Integer)
Public Event MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
Public Event MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
Public Event MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
Public Event Click(x As Single, y As Single)
Public Event DblClick(x As Single, y As Single)
Public Event KeyDown(KeyCode As Integer, Shift As Integer)
Public Event KeyPress(KeyAscii As Integer)
' User functions
Public Function CharFromPos(x As Single, y As Single) As Long
    
End Function
' Memory edit
Private Function CHARFROMLINE(N As Long) As Long
    Dim pt As Long, i As Long, oldi As Long
    If N = 0 Then CHARFROMLINE = 0: Exit Function
    pt = 1
    Do While True
        i = InStr(i + 1, mText, Chr$(13))
        If i = 0 Then CHARFROMLINE = oldi + 1: OCFL = CHARFROMLINE: OCFLL = N: Exit Function
        If pt = N Then CHARFROMLINE = i + 1: OCFL = CHARFROMLINE: OCFLL = N: Exit Function
        oldi = i
        pt = pt + 1
    Loop
End Function
Private Function LINEFROMCHAR(Optional N As Long = -1) As Long
    If N = -1 Then N = mSelStart
    Dim pt As Long, i As Long, oldi As Long
'    If LFCB Then LINEFROMCHAR = oldLinelfc:   Exit Function
    oldi = 0
    Do While True
        i = InStr(oldi + 1, mText, Chr$(13))
        If N >= oldi And N <= i Then LINEFROMCHAR = pt: oldLinelfc = pt: Exit Function
        If i = 0 Then LINEFROMCHAR = pt: oldLinelfc = pt: Exit Function
        oldi = i
        pt = pt + 1
    Loop
End Function
Private Sub REPLACE_SEL(V As String)
    Dim ss As Long, se As Long, tx As String
    Dim oC As Long
    Dim sL As Long, eL As Long
    Dim pt As Long
    If m_Locked Then Exit Sub
    ss = mSelStart: se = ss + mSelLenght
    If ss = 0 Then
        mText = V + Mid$(mText, se + 1)
    Else
        mText = Mid$(mText, 1, ss) + V + Mid$(mText, se + 1)
    End If
End Sub
Private Function GET_LINECOUNT() As Long
    Dim pt As Long, i As Long
    'If GLC Then GET_LINECOUNT = oldLineglc: Exit Function
    i = InStr(1, mText, Chr$(13))
    If i = 0 Then
        GET_LINECOUNT = 1
        oldLineglc = GET_LINECOUNT
        GLC = True
    Else
        pt = 1
        Do While True
            i = InStr(i + 1, mText, Chr$(13))
            If i = 0 Then
                If GET_LINE(pt) = "" Then GET_LINECOUNT = pt + 1 Else GET_LINECOUNT = pt + 1
                oldLineglc = GET_LINECOUNT
                GLC = True
                Exit Do
            End If
            pt = pt + 1
        Loop
    End If
End Function
Private Function GET_NEXTLINE() As String
    Dim z As Long, i As Long
    If bufCharCurLine = 0 Then Exit Function
    z = InStr(bufCharCurLine, mText, Chr$(13))
    If z = 0 Then Exit Function
    z = z + 2
    i = InStr(z, mText, Chr$(13))
    If i = 0 Then
        GET_NEXTLINE = Mid$(mText, z)
    Else
        GET_NEXTLINE = Mid$(mText, z, i - z)
    End If
    bufCharCurLine = z
    oldLine = oldLine + 1
End Function
Private Function GET_LINE(Num As Long) As String  ' Start as 0
    Dim pt As Long, z As Long, i As Long
    If Num = 0 Then
        i = InStr(1, mText, Chr$(13))
        If i = 0 Then
            GET_LINE = mText
        Else
            GET_LINE = Mid$(mText, 1, i - 1)
        End If
        oldLine = Num
        bufCharCurLine = i
        Exit Function
    End If
    Do While pt < Num
        z = InStr(z + 1, mText, Chr$(13))
        pt = pt + 1
    Loop
    z = z + 2
    i = InStr(z, mText, Chr$(13))
    If i = 0 Then
        GET_LINE = Mid$(mText, z)
    Else
        GET_LINE = Mid$(mText, z, i - z)
    End If
    oldLine = Num
    bufCharCurLine = z
End Function
Private Sub CalcNumericWidth()
    Dim cl As Long, ds As String, Max As Long, p As Long, ms As Long, j As Long
    cl = GET_LINECOUNT()
    Max = TextWidth("8")
    OldNumericWidth = NumericWidth
    NumericWidth = IIf(cl > 9999, Max * 5, IIf(cl > 999, Max * 4, IIf(cl > 99, Max * 3, IIf(cl > 9, Max * 2, Max))))
    NumericWidth = NumericWidth + 2
End Sub
Private Sub ChangeNumColor()
    If nBrush <> 0 Then DeleteObject nBrush
    nBrush = CreateSolidBrush(m_NumericBackColor)
End Sub
Private Sub ChangeUserColor()
    If uBrush <> 0 Then DeleteObject uBrush
    uBrush = CreateSolidBrush(m_UserBarColor)
End Sub

Private Sub VerifyScroll()
    Dim hT As Long, vh As Long
    hT = TextHeight("A")
    vh = (UserControl.ScaleHeight - m_OffsetTextY) \ hT - 1
    hT = GET_LINECOUNT() - vh
    If hT <= 0 Then mVScrollMax = 0 Else mVScrollMax = hT - 1
    If mOldVScrollMax <> mVScrollMax Then RaiseEvent ChangeVScroll(mVScrollMax, mVscroll)
    mOldVScrollMax = mVScrollMax
End Sub
Private Sub VScrollText()
    Dim sRC As RECT, vRC As RECT, hT As Long, y As Long, fL As Long, tL As Long
    Dim fC As Long, tC As Long, xC As Long
    hT = TextHeight("A")
    sRC.Left = 0: sRC.Top = m_OffsetTextY: sRC.Bottom = UserControl.ScaleHeight: sRC.Right = UserControl.ScaleWidth
    y = (mOldVScroll - mVscroll) * hT
    If y = 0 Then Exit Sub
    ScrollDC UserControl.hdc, 0, y, sRC, sRC, 0, vRC
    ' Get valid line
    If mOldVScroll < mVscroll Then
        ' Valid next line
        fL = (UserControl.ScaleHeight - m_OffsetTextY) \ hT + mOldVScroll
        tL = (UserControl.ScaleHeight - m_OffsetTextY) \ hT + mVscroll + 1
        Debug.Print mVscroll & "  " & mOldVScroll
        DrawLine fL, DT_FROMCURRENT_LINE
        If mSelLenght > 0 Then
            ' Paint selection
            fC = CHARFROMLINE(fL)
            tC = CHARFROMLINE(tL)
            If Not (fC < mSelStart And tC < mSelStart) Then
                If fC < mSelStart And tC > mSelStart Then
                    DrawSelection mSelStart
                ElseIf fC >= mSelStart Then
                    DrawSelection fC
                End If
            End If
        End If
    Else
        ' Valid prev line
        fL = mVscroll
        tL = mOldVScroll
        DrawLine fL, tL - fL
        If mSelLenght > 0 Then
            ' Paint selection
            fC = CHARFROMLINE(fL)
            tC = CHARFROMLINE(tL)
            If Not (fC > mSelStart + mSelLenght And tC > mSelStart + mSelLenght) Then
                If fC < mSelStart And tC > mSelStart Then
                    If tC > mSelStart + mSelLenght Then tC = mSelStart + mSelLenght
                    DrawSelection mSelStart, tC
                ElseIf fC >= mSelStart Then
                    If tC > mSelStart + mSelLenght Then tC = mSelStart + mSelLenght
                    DrawSelection fC, tC  '- mSelLenght
                End If
            End If
        End If
    End If
    mOldVScroll = mVscroll
End Sub
Private Sub DrawLine(Optional ByVal FromLine As Long = DT_CURRENTLINE, Optional ByVal NumOfLine As Long = 1, Optional IgnoreCurLine As Boolean)
    Dim x As Long, y As Long, hT As Long, wT As Long
    Dim hBrush As Long, OldBrush As Long, RC As RECT
    Dim fL As Long, curL As Long, nL As Long, cl As Long
    Dim bL As String, tC As String, tS As String, pS As Long, vmc As String
    Dim iB As Boolean, rep As Boolean, iE As Boolean, cS As Long
    Dim bS As Boolean, bC As Boolean, mC As Boolean, ctL As Long
    Dim nbW As Long, totOffst As Long, hObj As HighlightLine, tBrsh As Long
    If NumOfLine = 0 Then Exit Sub
    ctL = GET_LINECOUNT
    If NumOfLine = DT_ALL_LINE Then NumOfLine = ctL: FromLine = 0: iE = True
    If FromLine = -1 Then FromLine = LINEFROMCHAR(): LFCB = True
    If NumOfLine = DT_FROMCURRENT_LINE Then
        NumOfLine = ctL - FromLine
        iE = True
    End If
    ' Calculate width numeric bar and user bar
    If m_NumericBarEnable Then totOffst = m_OffsetTextX + NumericWidth Else totOffst = m_OffsetTextX
    If m_UserBarEnable Then totOffst = totOffst + m_UserBarWidth
    x = totOffst
    y = m_OffsetTextY
    hT = TextHeight("A")
    hBrush = GetCurrentObject(UserControl.hdc, OBJ_BRUSH)
    If FromLine < mVscroll Then FromLine = mVscroll
    y = y + (FromLine - mVscroll) * hT
    If iE Then
        RC.Top = y: RC.Bottom = UserControl.ScaleHeight
        If m_UserBarEnable Then
            ' Erase userbar
            RC.Left = 0: RC.Right = m_UserBarWidth
            FillRect UserControl.hdc, RC, uBrush
        End If
        If m_NumericBarEnable Then
            ' Erase numeric array
            RC.Left = RC.Right: RC.Right = NumericWidth + RC.Left
            FillRect UserControl.hdc, RC, nBrush
        End If
            ' Erase code array
        RC.Left = x - m_OffsetTextX: RC.Right = UserControl.ScaleWidth
        FillRect UserControl.hdc, RC, hBrush
    End If
    curL = LINEFROMCHAR()
    'nL - pointer line
    'cL - current line
    Do While (nL < NumOfLine) And (y < UserControl.ScaleHeight) 'And cl < ctL
        cl = nL + FromLine
        rep = False
        ' Prepare & erase bkgnd
        If Not iE Then
            RC.Top = y: RC.Bottom = RC.Top + hT
            RC.Right = 0
            If m_UserBarEnable Then
                ' Erase userbar
                RC.Left = 0: RC.Right = m_UserBarWidth
                FillRect UserControl.hdc, RC, uBrush
            End If
            If m_NumericBarEnable Then
                ' Erase numeric array
                RC.Left = RC.Right: RC.Right = RC.Left + NumericWidth
                FillRect UserControl.hdc, RC, nBrush
            End If
                ' Erase code array
            RC.Left = x - m_OffsetTextX: RC.Right = UserControl.ScaleWidth
            FillRect UserControl.hdc, RC, hBrush
        End If
        ' If HighLight
        If m_HighlightEnable Then
            For Each hObj In mHighLightGroup
                If hObj.Line = cl Then
                    If hObj.TypeHighLight And TH_FILLBACKGROUNDCOLOR Then
                        RC.Left = 0: RC.Right = UserControl.ScaleWidth: RC.Top = y: RC.Bottom = y + hT
                        tBrsh = CreateSolidBrush(hObj.ParamFill)
                        FillRect UserControl.hdc, RC, tBrsh
                        DeleteObject tBrsh
                    End If
                    If hObj.TypeHighLight And TH_COLOR Then
                        If nL = 0 Then bL = GET_LINE(cl) Else bL = GET_NEXTLINE
                        'Paint numeric bar
                        SetTextColor UserControl.hdc, hObj.Param
                        If m_NumericBarEnable Then
                            tC = Trim(Str(cl))
                            TextOut UserControl.hdc, IIf(m_UserBarEnable, m_UserBarWidth, 0), y, tC, Len(tC)
                        End If
                        'Paint no-formated text
                        TextOut UserControl.hdc, x, y, bL, Len(bL)
                        rep = True
                    End If
                    If hObj.TypeHighLight And TH_PICTURE Then
                        If m_UserBarEnable Then
                            oldBitmap = SelectObject(tempDC, hObj.ParamhBitmap)
                            BitBlt UserControl.hdc, 0, y, m_UserBarWidth, hT, tempDC, 0, 0, vbSrcCopy
                            SelectObject tempDC, oldBitmap
                        End If
                        Exit For
                    End If
                    If rep Then Exit For
                End If
            Next
        End If
        If Not rep Then
            If nL = 0 Then bL = GET_LINE(cl) Else bL = GET_NEXTLINE
            If ((cl = curL) And (Not IgnoreCurLine)) Or Not (m_ReservedWordHighlightEnable) Then
                'Paint numeric bar
                If m_NumericBarEnable Then
                    tC = Trim(Str(cl))
                    SetTextColor UserControl.hdc, m_NumericColor
                    TextOut UserControl.hdc, IIf(m_UserBarEnable, m_UserBarWidth, 0), y, tC, Len(tC)
                End If
                'Paint no-formated text
                SetTextColor UserControl.hdc, mDefaulColor
                TextOut UserControl.hdc, x, y, bL, Len(bL)
            Else
                ' Paint Numeric bar
                If m_NumericBarEnable Then
                    tC = Trim(Str(cl))
                    SetTextColor UserControl.hdc, m_NumericColor
                    TextOut UserControl.hdc, IIf(m_UserBarEnable, m_UserBarWidth, 0), y, tC, Len(tC)
                End If
                pS = 1
                tC = ""
                ' Paint formated text
                Do While pS <= Len(bL)
                    tS = Mid$(bL, pS, 1)
                    iB = tS < "0" Or (tS > "9" And tS < "A")
                    If (iB Or pS = Len(bL)) And Not (bS Or bC) Then
                        ' Split found
                        If pS = Len(bL) Then tC = tC + tS
                            For Each robj In mReservedGroup
                                If robj.Enable Then
                                    If robj.CaseSensitivity Then cS = vbBinaryCompare Else cS = vbTextCompare
                                    SetTextColor UserControl.hdc, robj.Color
                                    For Each wobj In robj.Words
                                        If StrComp(tC, wobj.Word, cS) = 0 And wobj.Enable Then
                                            If robj.AutoShift Then
                                                wT = TextWidth(wobj.Word)
                                                TextOut UserControl.hdc, x, y, wobj.Word, Len(wobj.Word)
                                            Else
                                                wT = TextWidth(tC)
                                                TextOut UserControl.hdc, x, y, tC, Len(tC)
                                            End If
                                            x = x + wT
                                            tC = ""
                                            rep = True
                                            Exit For
                                        End If
                                    Next
                                    If rep Then rep = False: Exit For
                                End If
                            Next
                        SetTextColor UserControl.hdc, mDefaulColor
                        ' Paint no-formated text
                        If pS <> Len(bL) And tS <> m_StringSymbol And tS <> m_CommentsSymbol Then tC = tC + tS
                        wT = TextWidth(tC)
                        TextOut UserControl.hdc, x, y, tC, Len(tC)
                        x = x + wT
                        If (tS = m_StringSymbol) And (Not bC) Then tC = m_StringSymbol: bS = True Else tC = ""
                        If (tS = m_CommentsSymbol) And (Not bS) Then tC = m_CommentsSymbol: bC = True
                    ElseIf (bS = True) Then
                        tC = tC + tS
                        If pS = Len(bL) And tS <> m_StringSymbol Then
                            bS = False
                            wT = TextWidth(tC)
                            SetTextColor UserControl.hdc, mDefaulColor
                            TextOut UserControl.hdc, x, y, tC, Len(tC)
                            tC = ""
                        End If
                        If tS = m_StringSymbol Then
                            bS = False
                            wT = TextWidth(tC)
                            SetTextColor UserControl.hdc, m_StringColor
                            TextOut UserControl.hdc, x, y, tC, Len(tC)
                            tC = ""
                            x = x + wT
                        End If
                    ElseIf (bC = True) Then
                        tC = tC + tS
                        If pS = Len(bL) Then
                            bC = False
                            wT = TextWidth(tC)
                            SetTextColor UserControl.hdc, m_CommentsColor
                            TextOut UserControl.hdc, x, y, tC, Len(tC)
                            tC = ""
                        End If
                    Else
                        tC = tC + tS
                    End If
                    pS = pS + 1
                Loop
            End If
        Else
        rep = False
        End If
        x = totOffst: y = y + hT: nL = nL + 1
    Loop
'    Debug.Print "END DRAW LINE"
End Sub
Private Sub UserControl_ExitFocus()
    HideCaret UserControl.hwnd
    DestroyCaret
    Focus = False
End Sub
Private Sub MoveCaret()
    Dim x As Long, y As Long, nL As Long, K As String, hT As Long
    Dim totOfst As Long
    If Not Focus Then Exit Sub
    If m_NumericBarEnable Then totOfst = m_OffsetTextX + NumericWidth Else totOfst = m_OffsetTextX
    If m_UserBarEnable Then totOfst = totOfst + m_UserBarWidth
    hT = TextHeight("A")
    Debug.Print "MOVE CAET"
    nL = LINEFROMCHAR(mSelStart)
    If nL < 0 Then Exit Sub
    y = nL * hT + m_OffsetTextY - (mVscroll * hT)
    If y > UserControl.ScaleHeight - hT + 1 Then
        mVscroll = mVscroll + 1
        y = y - hT
        VScrollText
        RaiseEvent ChangeVScroll(mVScrollMax, mVscroll)
    End If
    If y < 0 Then mVscroll = mVscroll - 1: VScrollText: RaiseEvent ChangeVScroll(mVScrollMax, mVscroll)
    x = mSelStart - CHARFROMLINE(nL)
    K = GET_LINE(nL)
    If x <> 0 Then
        If x < 0 Then Exit Sub
        K = Mid$(K, 1, x)
        x = TextWidth(K) + totOfst
    Else
        x = totOfst
    End If
    SetCaretPos x, y
End Sub
Private Sub UserControl_GotFocus()
    Focus = True
    CreateCaret UserControl.hwnd, 0, 1, 15
    MoveCaret
    ShowCaret UserControl.hwnd
End Sub

Private Sub UserControl_Initialize()
    tempDC = CreateCompatibleDC(UserControl.hdc)
    SetBkMode UserControl.hdc, TRANSPARENT
    bufCharCurLine = -1
    oldLine = -1
    OCFL = -1
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
    Dim cl As Long, cS As Long, ll As Long, z As String, lC As Long, lfC As Long, fC As Long, tC As Long, ol As Long
    Dim c As Integer
    If Not m_Enable Then Exit Sub
    RaiseEvent KeyDown(KeyCode, Shift)
    Select Case KeyCode
    Case VK_UP
        DrawSelection
        mSelLenght = 0
        cl = LINEFROMCHAR()
        ol = cl
        cS = CHARFROMLINE(cl)
        cS = mSelStart - cS
        cl = cl - 1
        If cl < 0 Then
            z = GetLine(0)
            ll = Len(z)
            If ll < cS Then cS = ll
            mSelStart = cS
        Else
            z = GetLine(cl)
            ll = Len(z)
            cl = CHARFROMLINE(cl)
            If ll < cS Then cS = ll
            mSelStart = cl + cS
        End If
        HideCaret UserControl.hwnd
        MoveCaret
        DrawLine ol, 1, True
        ShowCaret UserControl.hwnd
    Case VK_DOWN
        DrawSelection
        mSelLenght = 0
        lC = GET_LINECOUNT() '- 1
        ol = LINEFROMCHAR()
        cl = ol
        cS = CHARFROMLINE(cl)
        lfC = cS
        cS = mSelStart - cS
        cl = cl + 1
        If cl > lC Then
            z = GetLine(lC)
            ll = Len(z)
            If ll < cS Then cS = ll
            mSelStart = cS + lfC
        Else
            z = GET_LINE(cl)
            ll = Len(z)
            cl = CHARFROMLINE(cl)
            If ll < cS Then cS = ll
            mSelStart = cl + cS
        End If
        HideCaret UserControl.hwnd
        DrawLine ol, 1, True
        MoveCaret
        ShowCaret UserControl.hwnd
    Case VK_LEFT
        HideCaret UserControl.hwnd
        If Shift = 0 Then
            DrawSelection
            If mSelLenght = 0 Then mSelStart = mSelStart - 1
            mSelLenght = 0
            If mSelStart < 0 Then
                mSelStart = 0
            Else
                LFCB = False
                If Mid$(mText, mSelStart + 1, 1) = Chr$(13) Then
                    ol = LINEFROMCHAR(mSelStart + 2)
                    DrawLine ol, 1, True
                    mSelStart = mSelStart - 1
                End If
            End If
            tSelection = mSelStart
        ElseIf Shift = 1 Then
            '========
            If mSelStart + mSelLenght = tSelection Then
                ' If from above to below
                tC = mSelStart
                mSelStart = mSelStart - 1
                If Mid$(mText, mSelStart + 1, 1) = Chr$(10) Then mSelStart = mSelStart - 1: mSelLenght = mSelLenght + 1
                If mSelLenght = 0 Then mSelStart = tSelection - 1: mSelLenght = 1 Else mSelLenght = mSelLenght + 1
                DrawSelection mSelStart, tC
            ElseIf mSelStart + mSelLenght > tSelection Then
                ' If from below to above
                tC = mSelStart + mSelLenght
                mSelStart = tSelection
                mSelLenght = mSelLenght - 1
                If Mid$(mText, mSelStart + mSelLenght + 1, 1) = Chr$(10) Then mSelLenght = mSelLenght - 1
                DrawSelection mSelStart + mSelLenght, tC
            End If
            '=======
        End If
        MoveCaret
        ShowCaret UserControl.hwnd
    Case VK_RIGHT
        HideCaret UserControl.hwnd
        If Shift = 0 Then
            DrawSelection
            If mSelLenght > 0 Then mSelStart = mSelStart + mSelLenght Else mSelStart = mSelStart + 1
            mSelLenght = 0
            If mSelStart > Len(mText) Then mSelStart = Len(mText)
            If Mid$(mText, mSelStart + 1, 1) = Chr$(10) Then
                ol = LINEFROMCHAR(mSelStart - 1)
                DrawLine ol, 1, True
                mSelStart = mSelStart + 1
            End If
            tSelection = mSelStart
        ElseIf Shift = 1 Then
            '========
            If mSelStart + mSelLenght <= tSelection Then
                ' If from above to below
                fC = mSelStart
                mSelStart = mSelStart + 1
                If mSelLenght = 0 Then mSelStart = tSelection + 1: mSelLenght = 1 Else mSelLenght = mSelLenght - 1
                If Mid$(mText, mSelStart + 1, 1) = Chr$(10) Then mSelStart = mSelStart + 1: mSelLenght = mSelLenght - 1
                DrawSelection fC, mSelStart
            ElseIf mSelStart + mSelLenght > tSelection Then
                ' If from below to above
                mSelStart = tSelection
                fC = mSelStart + mSelLenght
                mSelLenght = mSelLenght + 1
                If Mid$(mText, mSelStart + mSelLenght + 1, 1) = Chr$(10) Then mSelLenght = mSelLenght + 1
                DrawSelection fC, mSelStart + mSelLenght
            End If
            '=======
        End If
        MoveCaret
        ShowCaret UserControl.hwnd
    Case VK_DELETE
        RaiseEvent ChangeText(c)
        If c <> 0 Then Exit Sub
        If mSelLenght > 0 Then
            GLC = False
            LFCB = False
            cl = NumericWidth
            REPLACE_SEL ""
            mSelLenght = 0
            HideCaret UserControl.hwnd
            MoveCaret
            VerifyScroll
            CalcNumericWidth
            If NumericWidth <> OldNumericWidth Then
                DrawLine , DT_ALL_LINE
            Else
                DrawLine , DT_FROMCURRENT_LINE
            End If
            ShowCaret UserControl.hwnd
        Else
            If Mid$(mText, mSelStart + 1, 1) = Chr$(13) Then
                GLC = False
                LFCB = False
                mSelLenght = 2
                REPLACE_SEL ""
                mSelLenght = 0
                cl = LINEFROMCHAR()
                VerifyScroll
                CalcNumericWidth
                If OldNumericWidth <> NumericWidth Then DrawLine , DT_ALL_LINE Else DrawLine , DT_FROMCURRENT_LINE
            Else
                mSelLenght = 1
                REPLACE_SEL ""
                mSelLenght = 0
                cl = LINEFROMCHAR()
                DrawLine
            End If
        End If
    End Select
End Sub

Private Sub UserControl_KeyPress(KeyAscii As Integer)
    If Not m_Enable Then Exit Sub
    RaiseEvent KeyPress(KeyAscii)
    Dim ol As Long, c As Integer
    Select Case KeyAscii
    Case 13, 10 ' Enter
        RaiseEvent ChangeText(c)
        If c <> 0 Then Exit Sub
        GLC = False
        LFCB = False
        ol = LINEFROMCHAR()
        REPLACE_SEL vbCrLf
        HideCaret UserControl.hwnd
        VerifyScroll
        CalcNumericWidth
        If OldNumericWidth <> NumericWidth Then DrawLine , DT_ALL_LINE, True: OldNumericWidth = NumericWidth Else DrawLine ol, DT_FROMCURRENT_LINE, True
        mSelStart = mSelStart + 2
        MoveCaret
        ShowCaret UserControl.hwnd
    Case 8  ' BackSpace
        RaiseEvent ChangeText(c)
        If c <> 0 Then Exit Sub
        If mSelLenght > 0 Then
            GLC = False
            LFCB = False
            REPLACE_SEL ""
            mSelLenght = 0
            cl = LINEFROMCHAR()
            HideCaret UserControl.hwnd
            MoveCaret
            VerifyScroll
            CalcNumericWidth
            If OldNumericWidth <> NumericWidth Then DrawLine , DT_ALL_LINE Else DrawLine , DT_FROMCURRENT_LINE
            ShowCaret UserControl.hwnd
            Exit Sub
        End If
        mSelStart = mSelStart - 1
        If mSelStart < 0 Then mSelStart = 0: Exit Sub
        If Mid$(mText, mSelStart + 1, 1) = Chr(10) Then
            GLC = False
            LFCB = False
            mSelStart = mSelStart - 1
            mSelLenght = 2
            REPLACE_SEL ""
            VerifyScroll
            CalcNumericWidth
        Else
            mSelLenght = 1
            REPLACE_SEL ""
        End If
        HideCaret UserControl.hwnd
        If mSelLenght = 2 Then
            mSelLenght = 0
            If OldNumericWidth <> NumericWidth Then DrawLine , DT_ALL_LINE Else DrawLine , DT_FROMCURRENT_LINE
        Else
            mSelLenght = 0
            DrawLine
        End If
        MoveCaret
        ShowCaret UserControl.hwnd
    Case 22     ' Ctrl+V
        RaiseEvent ChangeText(c)
        If c <> 0 Then Exit Sub
        GLC = False
        LFCB = False
        REPLACE_SEL Clipboard.GetText
        mSelStart = mSelStart + 1
        mSelLenght = 0
        HideCaret UserControl.hwnd
        VerifyScroll
        CalcNumericWidth
        If OldNumericWidth <> NumericWidth Then DrawLine , DT_ALL_LINE Else DrawLine , DT_FROMCURRENT_LINE
        MoveCaret
        ShowCaret UserControl.hwnd
        mSelLenght = 0
    Case 3     ' Ctrl+C
        Clipboard.Clear
        Clipboard.SetText SelText
    Case 24     ' Ctrl+X
        RaiseEvent ChangeText(c)
        If c <> 0 Then Exit Sub
        GLC = False
        LFCB = False
        Clipboard.Clear
        Clipboard.SetText SelText
        If mSelLenght > 0 Then
            REPLACE_SEL ""
            mSelLenght = 0
            cl = LINEFROMCHAR()
            HideCaret UserControl.hwnd
            MoveCaret
            VerifyScroll
            CalcNumericWidth
            If OldNumericWidth <> NumericWidth Then DrawLine , DT_ALL_LINE Else DrawLine , DT_FROMCURRENT_LINE
            ShowCaret UserControl.hwnd
        End If
    Case Else   ' Other key
        RaiseEvent ChangeText(c)
        If c <> 0 Then Exit Sub
        REPLACE_SEL Chr$(KeyAscii)
        mSelStart = mSelStart + 1
        If mSelLenght > 0 Then
            GLC = False
            LFCB = False
            mSelLenght = 0
            HideCaret UserControl.hwnd
            If OldNumericWidth <> NumericWidth Then DrawLine , DT_ALL_LINE Else DrawLine , DT_FROMCURRENT_LINE
            MoveCaret
            ShowCaret UserControl.hwnd
        Else
            mSelLenght = 0
            HideCaret UserControl.hwnd
            DrawLine
            MoveCaret
            ShowCaret UserControl.hwnd
        End If
        mSelLenght = 0
    End Select
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=8,0,0,2
Public Property Get OffsetTextX() As Long
    OffsetTextX = m_OffsetTextX
End Property

Public Property Let OffsetTextX(ByVal New_OffsetTextX As Long)
    m_OffsetTextX = New_OffsetTextX
    PropertyChanged "OffsetTextX"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=8,0,0,2
Public Property Get OffsetTextY() As Long
    OffsetTextY = m_OffsetTextY
End Property

Public Property Let OffsetTextY(ByVal New_OffsetTextY As Long)
    m_OffsetTextY = New_OffsetTextY
    PropertyChanged "OffsetTextY"
End Property

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_OffsetTextX = m_def_OffsetTextX
    m_OffsetTextY = m_def_OffsetTextY
    m_SelectionColor = m_def_SelectionColor
    m_HighlightEnable = m_def_HighlightEnable
    m_StringSymbol = m_def_StringSymbol
    m_CommentsSymbol = m_def_CommentsSymbol
    m_StringColor = m_def_StringColor
    m_CommentsColor = m_def_CommentsColor
    m_MultiLineCommentsOpen = m_def_MultiLineCommentsOpen
    m_MultilLineCommentsClose = m_def_MultilLineCommentsClose
    m_NumericBarEnable = m_def_NumericBarEnable
    m_NumericColor = m_def_NumericColor
    m_NumericBackColor = m_def_NumericBackColor
    m_UserBarEnable = m_def_UserBarEnable
    m_UserBarColor = m_def_UserBarColor
    m_UserBarWidth = m_def_UserBarWidth
    m_ReservedWordHighlightEnable = m_def_ReservedWordHighlightEnable
    m_Locked = m_def_Locked
    m_Enable = m_def_Enable
End Sub
Private Sub DrawSelection(Optional FromChar As Long = -1, Optional ToChar As Long = -1)
    Dim fL As Long, sL As Long, tL As Long, eL As Long, pt As Long, bT As String, wT As Long, hT As Long, RC As RECT
    Dim fC As Long, fX As Long, tC As Long, sell As Long, ol As Long, totOfst As Long
    If FromChar = -1 Then FromChar = mSelStart
    If ToChar = -1 Then ToChar = mSelStart + mSelLenght
    sell = ToChar - FromChar
    If sell <= 0 Then Exit Sub
    If m_NumericBarEnable Then totOfst = NumericWidth + m_OffsetTextX Else totOfst = m_OffsetTextX
    If m_UserBarEnable Then totOfst = totOfst + m_UserBarWidth
    hT = TextHeight("A")
    LFCB = False
    fL = LINEFROMCHAR(FromChar)
    tL = LINEFROMCHAR(ToChar)
    fC = CHARFROMLINE(fL)
    sL = fL - mVscroll
    eL = tL - mVscroll
    If eL < 0 Then Exit Sub
    ' P A I N T   S T A R T
    If sL < 0 Then
        ' If start selection hide to vscroll
        pt = fL - sL: sL = 0
    Else
        fC = FromChar - fC
        If fL = tL Then
        ' If selection only current line
            bT = GET_LINE(fL)
            fX = TextWidth(Mid$(bT, 1, fC))
            RC.Left = fX + totOfst: RC.Top = sL * hT + m_OffsetTextY: RC.Bottom = RC.Top + hT
            fX = TextWidth(Mid$(bT, fC + 1, sell))
            RC.Right = RC.Left + fX
            InvertRect UserControl.hdc, RC
            UserControl.DrawMode = vbCopyPen: Exit Sub
        Else
        ' If selection from current line to more...
            bT = GET_LINE(fL)
            fC = TextWidth(Mid$(bT, 1, fC))
            RC.Left = fC + totOfst: RC.Top = sL * hT + m_OffsetTextY: RC.Bottom = RC.Top + hT
            fC = TextWidth(bT)
            RC.Right = fC + totOfst
            'FillRect UserControl.hdc, RC, hSelectionBrush
            InvertRect UserControl.hdc, RC
            sL = sL + 1
        End If
        pt = fL + 1
    End If
    ' P A I N T   C E N T E R
    ol = pt
    Do While (pt < tL) And (RC.Top < UserControl.ScaleHeight)
        If ol = pt Then bT = GET_LINE(pt) Else bT = GET_NEXTLINE
        wT = TextWidth(bT)
        RC.Top = sL * hT + m_OffsetTextY: RC.Left = totOfst: RC.Bottom = RC.Top + hT: RC.Right = RC.Left + wT
        'FillRect UserControl.hdc, RC, hSelectionBrush
        InvertRect UserControl.hdc, RC
        sL = sL + 1
        pt = pt + 1
    Loop
    ' P A I N T   E N D
    If RC.Top > UserControl.ScaleHeight Then UserControl.DrawMode = vbCopyPen: Exit Sub
    bT = GET_LINE(tL)
    tC = CHARFROMLINE(tL)
    tC = ToChar - tC
    wT = TextWidth(Mid$(bT, 1, tC))
    RC.Top = sL * hT + m_OffsetTextY: RC.Left = totOfst: RC.Bottom = RC.Top + hT: RC.Right = RC.Left + wT
    InvertRect UserControl.hdc, RC
    UserControl.DrawMode = vbCopyPen
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim hT As Long, posLine As Long, posChar As Long, N As Long, xStr As String, tStr As String
    Dim ol As Long, nL As Long, totOfst As Long
    RaiseEvent MouseDown(Button, Shift, x, y)
    If m_NumericBarEnable Then totOfst = NumericWidth + m_OffsetTextX Else totOfst = m_OffsetTextX
    If m_UserBarEnable Then totOfst = totOfst + m_UserBarWidth
    x = x - totOfst
    If x < 0 Then Exit Sub ' Click on panel
    ol = LINEFROMCHAR()
    LFCB = False
    hT = TextHeight("A")
    posLine = ((y - m_OffsetTextY) \ hT) + mVscroll
    If posLine < 0 Then posLine = 0
    posChar = CHARFROMLINE(posLine)
    xStr = GET_LINE(posLine)
    N = 1
    Do While N <= Len(xStr)
        tStr = Mid$(xStr, 1, N)
        If TextWidth(tStr) >= x Then Exit Do
        N = N + 1
    Loop
    N = N - 1
    HideCaret UserControl.hwnd
    DrawSelection
    mSelStart = posChar + N
    mSelLenght = 0
    DrawLine ol
    DrawLine , , True
    boolSelection = True: tSelection = mSelStart
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim hT As Long, posLine As Long, posChar As Long, N As Long, xStr As String, tStr As String, tS As Long
    Dim fC As Long, tC As Long, vL As Long, oS As Long, totOfst As Long
    RaiseEvent MouseMove(Button, Shift, x, y)
    If m_NumericBarEnable Then totOfst = NumericWidth + m_OffsetTextX Else totOfst = m_OffsetTextX
    If m_UserBarEnable Then totOfst = totOfst + m_UserBarWidth
    x = x - totOfst
    If boolSelection Then
        hT = TextHeight("A")
        vL = ((UserControl.ScaleHeight - m_OffsetTextY) \ hT)
        posLine = ((y - m_OffsetTextY) \ hT) + mVscroll
        If posLine < 0 Then posLine = 0
        If posLine < mVscroll Then mVscroll = posLine: VScrollText: RaiseEvent ChangeVScroll(mVScrollMax, mVscroll)
        If posLine > mVscroll + vL Then
            ol = mVscroll
            mVscroll = posLine - vL
            If mVscroll > mVScrollMax Then mVscroll = mVScrollMax
            VScrollText
            If ol <> mVscroll Then RaiseEvent ChangeVScroll(mVScrollMax, mVscroll)
        End If
        posChar = CHARFROMLINE(posLine)
        xStr = GET_LINE(posLine)
        N = 1
        Do While N <= Len(xStr)
            tStr = Mid$(xStr, 1, N)
            If TextWidth(tStr) >= x Then Exit Do
            N = N + 1
        Loop
        N = N - 1
        tS = posChar + N
        If tS < tSelection Then
            ' If from above to below
            If (mSelLenght = tSelection - tS) And (mSelStart = tS) Then Exit Sub
            If (mSelStart + mSelLenght) > tSelection Then DrawSelection tSelection, mSelStart + mSelLenght
            tC = mSelStart
            mSelLenght = tSelection - tS
            mSelStart = tS
            fC = mSelStart
            If fC < tC Then DrawSelection fC, tC Else DrawSelection tC, fC
        ElseIf tS = tSelection Then
            fC = mSelStart: tC = mSelStart + mSelLenght
            mSelStart = tSelection
            mSelLenght = 0
            DrawSelection fC, tC
        Else
            ' If form below to above
            If (mSelLenght = tS - mSelStart) And (mSelStart = tSelection) Then Exit Sub
            If mSelStart < tSelection Then DrawSelection mSelStart, tSelection
            fC = mSelStart + mSelLenght
            mSelStart = tSelection
            mSelLenght = tS - mSelStart
            tC = mSelStart + mSelLenght
            If tC <= fC Then DrawSelection tC, fC Else DrawSelection fC, tC
        End If
    End If
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    RaiseEvent MouseUp(Button, Shift, x, y)
    boolSelection = False
    MoveCaret
    ShowCaret UserControl.hwnd
End Sub
Public Sub Refresh()
    DrawLine , DT_ALL_LINE
    DrawSelection
End Sub
Private Sub UserControl_Paint()
    DrawLine , DT_ALL_LINE
    DrawSelection
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    m_OffsetTextX = PropBag.ReadProperty("OffsetTextX", m_def_OffsetTextX)
    m_OffsetTextY = PropBag.ReadProperty("OffsetTextY", m_def_OffsetTextY)
    m_SelectionColor = PropBag.ReadProperty("SelectionColor", m_def_SelectionColor)
    m_HighlightEnable = PropBag.ReadProperty("HighlightEnable", m_def_HighlightEnable)
    mText = PropBag.ReadProperty("Text", m_def_Text)
    mDefaulColor = PropBag.ReadProperty("TextColor", m_def_DefaulColor)
    UserControl.BackColor = PropBag.ReadProperty("BackColor", m_def_BackColor)
    UserControl.FillColor = UserControl.BackColor
    m_StringSymbol = PropBag.ReadProperty("StringSymbol", "'")
    m_CommentsSymbol = PropBag.ReadProperty("CommentsSymbol", m_def_CommentsSymbol)
    m_StringColor = PropBag.ReadProperty("StringColor", m_def_StringColor)
    m_CommentsColor = PropBag.ReadProperty("CommentsColor", m_def_CommentsColor)
    m_NumericBarEnable = PropBag.ReadProperty("NumericBarEnable", m_def_NumericBarEnable)
    m_NumericColor = PropBag.ReadProperty("NumericColor", m_def_NumericColor)
    m_NumericBackColor = PropBag.ReadProperty("NumericBackColor", m_def_NumericBackColor)
    m_UserBarEnable = PropBag.ReadProperty("UserBarEnable", m_def_UserBarEnable)
    m_UserBarColor = PropBag.ReadProperty("UserBarColor", m_def_UserBarColor)
    m_UserBarWidth = PropBag.ReadProperty("UserBarWidth", m_def_UserBarWidth)
    m_ReservedWordHighlightEnable = PropBag.ReadProperty("ReservedWordHighlightEnable", m_def_ReservedWordHighlightEnable)
    m_Locked = PropBag.ReadProperty("Locked", m_def_Locked)
    m_Enable = PropBag.ReadProperty("Enable", m_def_Enable)
    ChangeNumColor
    ChangeUserColor
End Sub

Private Sub UserControl_Terminate()
    DeleteDC tempDC
    DeleteObject nBrush
    DeleteObject uBrush
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("OffsetTextX", m_OffsetTextX, m_def_OffsetTextX)
    Call PropBag.WriteProperty("OffsetTextY", m_OffsetTextY, m_def_OffsetTextY)
    Call PropBag.WriteProperty("HighlightEnable", m_HighlightEnable, m_def_HighlightEnable)
    Call PropBag.WriteProperty("BackColor", UserControl.BackColor, m_def_BackColor)
    Call PropBag.WriteProperty("TextColor", mDefaulColor, m_def_DefaulColor)
    Call PropBag.WriteProperty("Text", mText, m_def_Text)
    Call PropBag.WriteProperty("StringSymbol", m_StringSymbol, "'")
    Call PropBag.WriteProperty("CommentsSymbol", m_CommentsSymbol, m_def_CommentsSymbol)
    Call PropBag.WriteProperty("StringColor", m_StringColor, m_def_StringColor)
    Call PropBag.WriteProperty("CommentsColor", m_CommentsColor, m_def_CommentsColor)
    Call PropBag.WriteProperty("NumericBarEnable", m_NumericBarEnable, m_def_NumericBarEnable)
    Call PropBag.WriteProperty("NumericColor", m_NumericColor, m_def_NumericColor)
    Call PropBag.WriteProperty("NumericBackColor", m_NumericBackColor, m_def_NumericBackColor)
    Call PropBag.WriteProperty("UserBarEnable", m_UserBarEnable, m_def_UserBarEnable)
    Call PropBag.WriteProperty("UserBarColor", m_UserBarColor, m_def_UserBarColor)
    Call PropBag.WriteProperty("UserBarWidth", m_UserBarWidth, m_def_UserBarWidth)
    Call PropBag.WriteProperty("ReservedWordHighlightEnable", m_ReservedWordHighlightEnable, m_def_ReservedWordHighlightEnable)
    Call PropBag.WriteProperty("Locked", m_Locked, m_def_Locked)
    Call PropBag.WriteProperty("Enable", m_Enable, m_def_Enable)
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,True
Public Property Get HighlightEnable() As Boolean
    HighlightEnable = m_HighlightEnable
End Property

Public Property Let HighlightEnable(ByVal New_HighlightEnable As Boolean)
    m_HighlightEnable = New_HighlightEnable
    DrawLine 0, DT_ALL_LINE
    DrawSelection mSelStart, mSelStart + mSelLenght
    PropertyChanged "HighlightEnable"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=13,0,0,"
Public Property Get StringSymbol() As String
    StringSymbol = m_StringSymbol
End Property

Public Property Let StringSymbol(ByVal New_StringSymbol As String)
    If Len(New_CommentsSymbol) > 1 Then Exit Property
    m_StringSymbol = New_StringSymbol
    DrawLine 0, DT_ALL_LINE
    DrawSelection mSelStart, mSelStart + mSelLenght
    PropertyChanged "StringSymbol"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=13,0,0,;
Public Property Get CommentsSymbol() As String
    CommentsSymbol = m_CommentsSymbol
End Property

Public Property Let CommentsSymbol(ByVal New_CommentsSymbol As String)
    If Len(New_CommentsSymbol) > 1 Then Exit Property
    m_CommentsSymbol = New_CommentsSymbol
    DrawLine 0, DT_ALL_LINE
    DrawSelection mSelStart, mSelStart + mSelLenght
    PropertyChanged "CommentsSymbol"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,0
Public Property Get StringColor() As OLE_COLOR
    StringColor = m_StringColor
End Property

Public Property Let StringColor(ByVal New_StringColor As OLE_COLOR)
    m_StringColor = New_StringColor
    DrawLine 0, DT_ALL_LINE
    PropertyChanged "StringColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,0
Public Property Get CommentsColor() As OLE_COLOR
    CommentsColor = m_CommentsColor
End Property

Public Property Let CommentsColor(ByVal New_CommentsColor As OLE_COLOR)
    m_CommentsColor = New_CommentsColor
    DrawLine 0, DT_ALL_LINE
    DrawSelection mSelStart, mSelStart + mSelLenght
    PropertyChanged "CommentsColor"
End Property


'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,False
Public Property Get NumericBarEnable() As Boolean
    NumericBarEnable = m_NumericBarEnable
End Property

Public Property Let NumericBarEnable(ByVal New_NumericBarEnable As Boolean)
    m_NumericBarEnable = New_NumericBarEnable
    DrawLine 0, DT_ALL_LINE
    DrawSelection mSelStart, mSelStart + mSelLenght
    PropertyChanged "NumericBarEnable"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,&H0F0F0F
Public Property Get NumericColor() As OLE_COLOR
    NumericColor = m_NumericColor
End Property

Public Property Let NumericColor(ByVal New_NumericColor As OLE_COLOR)
    m_NumericColor = New_NumericColor
    DrawLine 0, DT_ALL_LINE
    DrawSelection mSelStart, mSelStart + mSelLenght
    PropertyChanged "NumericColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,vbWhite
Public Property Get NumericBackColor() As OLE_COLOR
    NumericBackColor = m_NumericBackColor
End Property

Public Property Let NumericBackColor(ByVal New_NumericBackColor As OLE_COLOR)
    m_NumericBackColor = New_NumericBackColor
    ChangeNumColor
    DrawLine 0, DT_ALL_LINE
    DrawSelection mSelStart, mSelStart + mSelLenght
    PropertyChanged "NumericBackColor"
End Property


Public Property Get Text() As String
    Text = mText
End Property

Public Property Let Text(vNewValue As String)
    If m_Locked Then Exit Property
    mText = vNewValue
    GLC = False
    VerifyScroll
    CalcNumericWidth
    DrawLine 0, DT_ALL_LINE
    DrawSelection mSelStart, mSelStart + mSelLenght
    PropertyChanged "Text"
End Property
Public Property Get VScrollValue() As Long
    VScrollValue = mVscroll
End Property
Public Property Let VScrollValue(ByVal vNewValue As Long)
    If vNewValue > mVScrollMax Then Exit Property
    mVscroll = vNewValue
    VScrollText
End Property

Public Property Get SelStart() As Long
    SelStart = mSelStart
End Property
Public Property Let SelStart(ByVal vNewValue As Long)
    If vNewValue > Len(mText) Then Exit Property
    DrawSelection mSelStart, mSelStart + mSelLenght
    mSelLenght = 0
    mSelStart = vNewValue
    If Not Focus Then Exit Property
    HideCaret UserControl.hwnd
    MoveCaret
    ShowCaret UserControl.hwnd
End Property
Public Property Get SelLenght() As Long
    SelLenght = mSelLenght
End Property
Public Property Let SelLenght(ByVal vNewValue As Long)
    If vNewValue + mSelStart > Len(mText) Then Exit Property
    DrawSelection mSelStart, mSelStart + mSelLenght
    mSelLenght = vNewValue
    DrawSelection mSelStart, mSelStart + mSelLenght
End Property
Public Property Get DefaulColor() As OLE_COLOR
    DefaulColor = mDefaulColor
End Property
Public Property Let DefaulColor(ByVal vNewValue As OLE_COLOR)
    mDefaulColor = vNewValue
    DrawLine 0, DT_ALL_LINE
    DrawSelection mSelStart, mSelStart + mSelLenght
    PropertyChanged "TextColor"
End Property
Public Property Get BackColor() As OLE_COLOR
    BackColor = UserControl.BackColor
End Property
Public Property Let BackColor(ByVal vNewValue As OLE_COLOR)
    UserControl.BackColor = vNewValue
    DrawLine 0, DT_ALL_LINE
    DrawSelection mSelStart, mSelStart + mSelLenght
    PropertyChanged "BackColor"
End Property

Public Property Let SelText(ByVal vNewValue As String)
    Call REPLACE_SEL(vNewValue)
    DrawLine 0, DT_ALL_LINE
    DrawSelection mSelStart, mSelStart + mSelLenght
End Property
Public Property Get SelText() As String
    SelText = Mid$(mText, mSelStart + 1, mSelLenght)
End Property
Public Property Get HighLightGroup() As HighLightGroup
    Set HighLightGroup = mHighLightGroup
End Property

Public Property Get ReservedGroup() As ReservedGroup
    Set ReservedGroup = mReservedGroup
End Property
Public Property Get GetLine(Index As Long) As String
    GetLine = GET_LINE(Index)
End Property
Public Property Get GetLineIndex(CharPos As Long) As Long
    GetLineIndex = LINEFROMCHAR(CharPos)
End Property
Public Property Get GetCharIndex(LinePos As Long) As Long
    GetCharIndex = CHARFROMLINE(LinePos)
End Property
Public Property Get GetFirstVisibleLine() As Long
    GetFirstVisibleLine = mVscroll
End Property
Public Property Get GetLineCount() As Long
    GetLineCount = GET_LINECOUNT
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,false
Public Property Get UserBarEnable() As Boolean
    UserBarEnable = m_UserBarEnable
End Property

Public Property Let UserBarEnable(ByVal New_UserBarEnable As Boolean)
    m_UserBarEnable = New_UserBarEnable
    DrawLine 0, DT_ALL_LINE
    DrawSelection mSelStart, mSelStart + mSelLenght
    PropertyChanged "UserBarEnable"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,vbred
Public Property Get UserBarColor() As OLE_COLOR
    UserBarColor = m_UserBarColor
End Property

Public Property Let UserBarColor(ByVal New_UserBarColor As OLE_COLOR)
    m_UserBarColor = New_UserBarColor
    ChangeUserColor
    DrawLine 0, DT_ALL_LINE
    DrawSelection mSelStart, mSelStart + mSelLenght
    PropertyChanged "UserBarColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=8,0,0,64
Public Property Get UserBarWidth() As Long
    UserBarWidth = m_UserBarWidth
End Property

Public Property Let UserBarWidth(ByVal New_UserBarWidth As Long)
    m_UserBarWidth = New_UserBarWidth
    DrawLine 0, DT_ALL_LINE
    DrawSelection mSelStart, mSelStart + mSelLenght
    PropertyChanged "UserBarWidth"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,false
Public Property Get ReservedWordHighlightEnable() As Boolean
    ReservedWordHighlightEnable = m_ReservedWordHighlightEnable
End Property

Public Property Let ReservedWordHighlightEnable(ByVal New_ReservedWordHighlightEnable As Boolean)
    m_ReservedWordHighlightEnable = New_ReservedWordHighlightEnable
    DrawLine 0, DT_ALL_LINE
    DrawSelection mSelStart, mSelStart + mSelLenght
    PropertyChanged "ReservedWordHighlightEnable"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,false
Public Property Get Locked() As Boolean
    Locked = m_Locked
End Property

Public Property Let Locked(ByVal New_Locked As Boolean)
    m_Locked = New_Locked
    PropertyChanged "Locked"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,True
Public Property Get Enable() As Boolean
    Enable = m_Enable
End Property

Public Property Let Enable(ByVal New_Enable As Boolean)
    m_Enable = New_Enable
    PropertyChanged "Enable"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=8,1,2,0
Public Property Get hdc() As Long
Attribute hdc.VB_MemberFlags = "400"
    hdc = UserControl.hdc
End Property


'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=8,1,2,0
Public Property Get hwnd() As Long
Attribute hwnd.VB_MemberFlags = "400"
    hwnd = UserControl.hwnd
End Property


